<xsl:stylesheet version="1.0"
                xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
                xmlns="http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd">
    <!--Convert XML paradigm file to HTML-->
    <xsl:output method="html"/>
    <xsl:template match="/Paradigms">     <!--Root-->
        <html>
            <xsl:text>&#x0A;</xsl:text>
            <head>
                <title><xsl:value-of select="@title"/></title>  <!--Ought to have a default -->
            </head>
            <xsl:text>&#x0A;</xsl:text>
            <body>
                <xsl:for-each select="POS">   <!--Top-level grouping is by POS-->
                    <h1 align="center">
                        <title><xsl:value-of select="./@name"/></title><xsl:text>&#x0A;</xsl:text>
                    </h1>
                    <xsl:for-each select="./Paradigm">
                        <p>
                        <table border="2" width="80%" cols="2">
                            <caption align="top"><strong><xsl:value-of select="@constant_features"/> paradigm of <xsl:value-of select="../@stem"/> with <xsl:value-of select="./@name"/></strong></caption>
                            <xsl:for-each select="./Cell">
                                <xsl:text>&#x0A;</xsl:text>
                                <tr>
                                    <td width="25%"><xsl:value-of select="normalize-space(PosFeatures)"/></td>
                                    <td width="75%">
                                        <!--Sub-table for the parses: -->
                                        <table border="0" cellpadding="5">
                                            <!--The 100% width forces the sub-table to take up the entire width, otherwise it
                                                 just takes up what it needs, and vertical alignment of columns is broken.-->
                                            <xsl:for-each select="Wordforms/parse">
                                                <tr>
                                                    <td>
                                                        <!--Sub-subtable for each parse: -->
                                                        <table border="0" cellspacing="0" cellpadding="0">
                                                            <tr><td style="color: red"><xsl:value-of select="@sr"/></td></tr>
                                                            <tr><td><xsl:value-of select="@ur"/></td></tr>
                                                            <tr><td><xsl:value-of select="@gl"/></td></tr>
                                                        </table>
                                                    </td>
                                                </tr>
                                            </xsl:for-each>
                                        </table>
                                    </td>
                                </tr>
                            </xsl:for-each>
                        </table>
                        </p>
                        <!--Add some extra space before the next table: -->
                        <br/>
                    </xsl:for-each>
                </xsl:for-each>
            </body>
        </html>
    </xsl:template>
</xsl:stylesheet>
